Subject: Re: Performance degradration 2.6.25->2.6.26

From: Elad Lahav <[email-masked]>
Date: Fri, 12 Sep 2008 10:58:37 -0400

>> HyperThreading, for a total of 4 logical processors, and 4 Intel Gigabit
>>   NICs on a PCI 64/66 bus (82546EB). In the experiments, I am pinning
>> four sending processes (one per NIC) to logical processors 0 and 2, and
>> the NIC interrupts to logical processors 1 and 3, such that interrupts
>> are serviced by the sibling logical processor of the one sending the
>> packets. I have used both the driver that comes with the Linux kernel
>> (7.3.20-k2-NAPI), as well as a more recent one (7.6.15.5).

I believe I have found the problem, and it has nothing to do with the driver.
Up to the latest kernel, logical processors on the same chip had sequential CPU IDs. So 
CPU 0 and CPU 1 were two logical processors on the first physical one, 2 and 3 on the 
second physical one, etc.
It seems that now this ordering has changed. I was running my experiments on logical 
processors 0 and 2, assuming they were on different physical processors, when, in fact, 
they were sharing the same one. When pinning the processes to logical processor 0 and 1, I 
get at least as good a performance as I do on previous kernels.

Thanks,
Elad

-------------------------------------------------------------------------
This SF.Net email is sponsored by the Moblin Your Move Developer's challenge
Build the coolest Linux based applications with Moblin SDK & win great prizes
Grand prize is a trip for two to an Open Source event anywhere in the world
http://moblin-contest.org/redirect.php?banner_id=100&url=/